/*************************************************************************
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 * 
 * Copyright 2008 by Sun Microsystems, Inc.
 *
 * OpenOffice.org - a multi-platform office productivity suite
 *
 * $RCSfile: Navigator.hxx,v $
 * $Revision: 1.4 $
 *
 * This file is part of OpenOffice.org.
 *
 * OpenOffice.org is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 3
 * only, as published by the Free Software Foundation.
 *
 * OpenOffice.org is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3 for more details
 * (a copy is included in the LICENSE file that accompanied this code).
 *
 * You should have received a copy of the GNU Lesser General Public License
 * version 3 along with OpenOffice.org.  If not, see
 * <http://www.openoffice.org/license.html>
 * for a copy of the LGPLv3 License.
 *
 ************************************************************************/
#ifndef INCLUDED_RPTUI_NAVIGATOR_HXX
#define INCLUDED_RPTUI_NAVIGATOR_HXX

#include <vcl/floatwin.hxx>
#include "ModuleHelper.hxx"
#include <memory>
namespace rptui
{
    class OReportController;
    class ONavigatorImpl;
    class ONavigator :  public FloatingWindow
    {
        OModuleClient	    m_aModuleClient;
        ::std::auto_ptr<ONavigatorImpl> m_pImpl;
        ONavigator(const ONavigator&);
        void operator =(const ONavigator&);
    public:
       	ONavigator( Window* pParent
					,OReportController& _rController);
	    virtual ~ONavigator();

	    // window
	    virtual void	Resize();
        virtual void GetFocus();
    };
// =============================================================================
} // namespace rptui
// =============================================================================
#endif // INCLUDED_RPTUI_NAVIGATOR_HXX
